//+-----------------------------------------------------------------------------+
//|                            1 min trailing BUY entry with be and x bar trail |
//|                                                               Edward Munroe |
//|                                                  Hugh Briss @ Forex Factory |
//+-----------------------------------------------------------------------------+
#property copyright "Edward Munroe"

extern double pipsgap = 0.0;
extern int pipsstop = 25;
extern int breakeven = 1;
extern double riskpercentperpip = 1.0;
extern int xbartrail = 0;
extern double commissionoffset = 0;

double UsePoint;
datetime currenttimestamp;
bool opentrade, pendingorder;
double pendingprice, buypendingprice, buystoploss, lotsize;
bool tradetaken;

int init()
{
UsePoint = PipPoint(Symbol());
currenttimestamp = iTime(NULL,0,0);
tradetaken = false;
return(0);
}

int start()
{
if(currenttimestamp != iTime(NULL,0,0))
  {
  currenttimestamp = iTime(NULL,0,0);
  bool NewBar = true;
  }
  else NewBar = false;
  
// Check for open trade or pending order
opentrade = false; pendingorder = false;
for(int counter1 = 0; counter1 <= OrdersTotal()-1; counter1++)
{
  OrderSelect(counter1, SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol() == Symbol())
  {
  if(OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice()) {opentrade = true; tradetaken = true;}
  if(OrderType() == OP_BUYSTOP) {pendingorder = true; pendingprice = OrderOpenPrice();}
  
  // Check for break even condition and move to break even
  if(OrderType() == OP_BUY && OrderStopLoss() <OrderOpenPrice() && Bid > (OrderOpenPrice() + ((breakeven + commissionoffset) * UsePoint))) OrderModify(OrderTicket(),OrderOpenPrice(),(OrderOpenPrice() + (commissionoffset *UsePoint)),0,0,CLR_NONE);
  }
}

// If no open trades and no pending orders then place 1 pending order x pips away from the current price in the direction set
if(opentrade == false && pendingorder == false && tradetaken == false)
{
while(IsTradeContextBusy()) Sleep(10); RefreshRates();
buypendingprice = iHigh(Symbol(),1,1) + (pipsgap * UsePoint)+((MarketInfo(Symbol(),MODE_SPREAD)/10) * UsePoint);
buystoploss = buypendingprice - (pipsstop * UsePoint);
lotsize = (((AccountEquity()/100)*riskpercentperpip)/MarketInfo(Symbol(),MODE_TICKVALUE))/10;
OrderSend(Symbol(),OP_BUYSTOP,lotsize,buypendingprice,100,buystoploss,0,0,0,0,CLR_NONE);
}
 if(NewBar == true)
  {
// If no open orders open but pending orders present check distance from current price and if more than x pips then modify
if(opentrade == false && pendingorder == true)
{
if(pendingprice > (iHigh(Symbol(),1,1) + pipsgap * UsePoint)+((MarketInfo(Symbol(),MODE_SPREAD)/10) * UsePoint))
{
buypendingprice = iHigh(Symbol(),1,1) + (pipsgap * UsePoint)+((MarketInfo(Symbol(),MODE_SPREAD)/10) * UsePoint);
buystoploss = buypendingprice - (pipsstop * UsePoint);
if(buypendingprice < pendingprice)
{
for(int counter3 = 0; counter3 <= OrdersTotal()-1; counter3++)
{
  OrderSelect(counter3, SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol() == Symbol() && OrderType() == OP_BUYSTOP)
{
OrderModify(OrderTicket(),buypendingprice,buystoploss,0,0,CLR_NONE);
}
}
}
}
}

// x bar trail
 
  // Find high and low of last x Bars

  int lowestshift = iLowest(NULL,0,MODE_LOW,xbartrail,1);
  buystoploss = Low[lowestshift] - (1*UsePoint);

  int highestshift = iHighest(NULL,0,MODE_HIGH,xbartrail,1);
  double sellstoploss = High[highestshift] + (3*UsePoint);

  // Find orders and trail behind high/low

  for(int counterw = 0; counterw <= OrdersTotal()-1; counterw++)
  {
  OrderSelect(counterw, SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol() == Symbol() && OrderStopLoss() >= OrderOpenPrice())
  {
  if(OrderType() == OP_BUY && buystoploss > OrderStopLoss())
  {
  while(IsTradeContextBusy()) Sleep(10); RefreshRates();
  OrderModify(OrderTicket(),OrderOpenPrice(),buystoploss,OrderTakeProfit(),0,Blue);
  }
  }
  }
  }

return(0);
}

double PipPoint(string Currency)
  {
  int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
  if(CalcDigits == 2 || CalcDigits == 3) double CalcPoint = 0.01;
  else if(CalcDigits == 4 || CalcDigits == 5) CalcPoint = 0.0001;
  return(CalcPoint);
  }
  

